﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace PensSample {
  partial class JoinsForm : Form {
    public JoinsForm() {
      InitializeComponent();
    }

    private void JoinsForm_Paint(object sender, PaintEventArgs e) {
      Graphics g = e.Graphics;
      string[] joinNames = Enum.GetNames(typeof(LineJoin));
      Array.Sort(joinNames);

      int x = 0;
      int y = 0;
      int width = this.ClientRectangle.Width / 2;
      int height = this.ClientRectangle.Height / ((joinNames.Length) / 2);
      Brush blackBrush = Brushes.Black;
      Pen blackPen = System.Drawing.Pens.Black;
      Pen whitePen = System.Drawing.Pens.White;

      foreach( string joinName in joinNames ) {
        using( Pen pen = new Pen(Color.Black, 12) ) {
          pen.LineJoin = (LineJoin)Enum.Parse(typeof(LineJoin), joinName);
          g.DrawRectangle(pen, new Rectangle(x + 20, y + 20, width - 40, height - 40));
          g.DrawRectangle(whitePen, new Rectangle(x + 20, y + 20, width - 40, height - 40));

          StringFormat format = new StringFormat();
          format.Alignment = StringAlignment.Center;
          format.LineAlignment = StringAlignment.Center;
          g.DrawString(joinName, this.Font, blackBrush, new Rectangle(x, y, width, height), format);

          x += width;
          if( x > this.ClientRectangle.Width - width ) {
            y += height;
            x = 0;
          }
        }
      }
    }
  }
}